vFW CDS CNF CBA with native k8s profile upload 32/113732/3
authorLukasz Rajewski <lukasz.rajewski@orange.com>
Fri, 9 Oct 2020 18:59:32 +0000 (20:59 +0200)
committerLukasz Rajewski <lukasz.rajewski@orange.com>
Fri, 9 Oct 2020 20:44:45 +0000 (22:44 +0200)
vFW CDS CNF CBA with native k8s profile upload

Change-Id: Ic3357982af534ea261d4d617e050dc33bc339645
Issue-ID: INT-1658
Signed-off-by: Lukasz Rajewski <lukasz.rajewski@orange.com>
28 files changed:
heat/vFW_CNF_CDS/templates/Makefile
heat/vFW_CNF_CDS/templates/cba-dev/build.sh [new file with mode: 0755]
heat/vFW_CNF_CDS/templates/cba-dev/deploy.sh [new file with mode: 0755]
heat/vFW_CNF_CDS/templates/cba-dev/run-vf-base-ra.sh [new file with mode: 0755]
heat/vFW_CNF_CDS/templates/cba-dev/run-vf-pkg-ra.sh [new file with mode: 0755]
heat/vFW_CNF_CDS/templates/cba-dev/run-vnf-ra.sh [new file with mode: 0755]
heat/vFW_CNF_CDS/templates/cba/Definitions/artifact_types.json
heat/vFW_CNF_CDS/templates/cba/Definitions/data_types.json
heat/vFW_CNF_CDS/templates/cba/Definitions/node_types.json
heat/vFW_CNF_CDS/templates/cba/Definitions/resources_definition_types.json
heat/vFW_CNF_CDS/templates/cba/Definitions/vFW_CNF_CDS.json
heat/vFW_CNF_CDS/templates/cba/Scripts/kotlin/KotlinK8sProfileUpload.kt [deleted file]
heat/vFW_CNF_CDS/templates/cba/TOSCA-Metadata/TOSCA.meta
heat/vFW_CNF_CDS/templates/cba/Templates/base_template-mapping.json
heat/vFW_CNF_CDS/templates/cba/Templates/base_template-template.vtl
heat/vFW_CNF_CDS/templates/cba/Templates/k8s-profiles/vfw-cnf-cds-vpkg-profile/manifest.yaml [new file with mode: 0644]
heat/vFW_CNF_CDS/templates/cba/Templates/k8s-profiles/vfw-cnf-cds-vpkg-profile/override_values.yaml [new file with mode: 0644]
heat/vFW_CNF_CDS/templates/cba/Templates/k8s-profiles/vfw-cnf-cds-vpkg-profile/ssh-service-mapping.json [moved from heat/vFW_CNF_CDS/templates/cba/Templates/k8s-profiles/ssh-service-mapping.json with 78% similarity]
heat/vFW_CNF_CDS/templates/cba/Templates/k8s-profiles/vfw-cnf-cds-vpkg-profile/ssh-service-template.yaml.vtl [moved from heat/vFW_CNF_CDS/templates/cba/Templates/k8s-profiles/ssh-service-template.vtl with 100% similarity]
heat/vFW_CNF_CDS/templates/cba/Templates/vfw-mapping.json
heat/vFW_CNF_CDS/templates/cba/Templates/vfw-template.vtl
heat/vFW_CNF_CDS/templates/cba/Templates/vnf-mapping.json
heat/vFW_CNF_CDS/templates/cba/Templates/vnf-template.vtl
heat/vFW_CNF_CDS/templates/cba/Templates/vpkg-mapping.json
heat/vFW_CNF_CDS/templates/cba/Templates/vpkg-template.vtl
heat/vFW_CNF_CDS/templates/cba/Templates/vsn-mapping.json
heat/vFW_CNF_CDS/templates/cba/Templates/vsn-template.vtl
heat/vFW_CNF_CDS/templates/cba/pom.xml [new file with mode: 0644]

index 66dbb29..38a4b38 100644 (file)
@@ -19,7 +19,7 @@ base: package/
        cp base/* package/
 
 cba: package/
-       cd cba/ && zip -r $(CBA_NAME).zip .
+       cd cba/ && zip -r $(CBA_NAME).zip . -x pom.xml .idea/\* target/\*
        mv cba/$(CBA_NAME).zip package/
 
 package/:
diff --git a/heat/vFW_CNF_CDS/templates/cba-dev/build.sh b/heat/vFW_CNF_CDS/templates/cba-dev/build.sh
new file mode 100755 (executable)
index 0000000..a7a3406
--- /dev/null
@@ -0,0 +1,39 @@
+#!/bin/sh
+
+# ============LICENSE_START=======================================================
+# Copyright (C) 2020 Orange
+# ================================================================================
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#      http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+# ============LICENSE_END=========================================================
+
+cd ../cba/
+
+mvn clean install
+
+if [ $? -eq 1 ]
+then
+   echo "----------------"
+   echo "CBA BUILD FAILED"
+   echo "----------------"
+   exit 1
+fi
+
+CBA_NAME=`ls target/*.zip`
+cp $CBA_NAME ../cba-dev/cba.zip
+
+echo "-----------------"
+echo "CBA BUILD SUCCESS"
+echo "-----------------"
+
+cd ../cba-dev
diff --git a/heat/vFW_CNF_CDS/templates/cba-dev/deploy.sh b/heat/vFW_CNF_CDS/templates/cba-dev/deploy.sh
new file mode 100755 (executable)
index 0000000..8ddbe49
--- /dev/null
@@ -0,0 +1,22 @@
+#!/bin/sh
+
+# ============LICENSE_START=======================================================
+# Copyright (C) 2020 Orange
+# ================================================================================
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#      http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+# ============LICENSE_END=========================================================
+
+curl --location --request POST 'http://127.0.0.1:8081/api/v1/blueprint-model/publish' \
+--header 'Authorization: Basic Y2NzZGthcHBzOmNjc2RrYXBwcw==' \
+--form 'file=@cba.zip' | jq
diff --git a/heat/vFW_CNF_CDS/templates/cba-dev/run-vf-base-ra.sh b/heat/vFW_CNF_CDS/templates/cba-dev/run-vf-base-ra.sh
new file mode 100755 (executable)
index 0000000..840bb85
--- /dev/null
@@ -0,0 +1,65 @@
+#!/bin/sh
+
+# ============LICENSE_START=======================================================
+# Copyright (C) 2020 Orange
+# ================================================================================
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#      http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+# ============LICENSE_END=========================================================
+
+REQ_ID=`shuf -i 1-1000000 -n 1`
+SUB_REQ_ID=$REQ_ID"-"`shuf -i 1-1000 -n 1`
+TEMPLATE_NAME="base_template"
+
+curl --location --request POST 'http://localhost:8081/api/v1/execution-service/process' \
+--header 'Authorization: Basic Y2NzZGthcHBzOmNjc2RrYXBwcw==' \
+--header 'Content-Type: application/json' \
+--data-raw '{
+    "commonHeader": {
+        "originatorId": "onap-me-cm-adapter",
+        "requestId": "'$REQ_ID'",
+        "subRequestId": "'$SUB_REQ_ID'"
+    },
+    "actionIdentifiers": {
+        "blueprintName": "vFW_CNF_CDS",
+        "blueprintVersion": "7.0.0",
+        "actionName": "resource-assignment",
+        "mode": "sync"
+    },
+    "payload": {
+        "resource-assignment-request": {
+            "template-prefix": [
+                "'$TEMPLATE_NAME'"
+            ],
+            "resolution-key": "ra-test-resolution",
+            "resource-assignment-properties": {
+                "vpg-management-port": 100,
+                "aic-cloud-region": "RegionOne",
+                "vnf-model-customization-uuid": "d73864db-1f6e-4e54-a533-a96773c926a4",
+                "service-instance-id": "2afee7c4-8b16-4f2f-a567-48fb7948abcf",
+                "vnf-id": "21dcbbd2-3ec2-4a9c-bb0d-599cafc16a1f",
+                "vnf_name": "sample-vnf-name",
+                "vf-module-name": "vf-module-name",
+                "vf-module-label": "'$TEMPLATE_NAME'",
+                "vf-module-type": "vf-module-type",
+                "vf-module-model-customization-uuid": "d3ae2df9-95d4-48cc-a466-9f12dee80458",
+                "vf-module-model-invariant-uuid": "564e55dc-3b90-4c9c-9e97-42f2c97d8f11",
+                "vf-module-model-version": "3d55e2a6-7634-4ceb-98e9-2852d621a544",
+                "vf-module-id": "3e6a0375-4b92-4bf5-9910-b0b893448a9c",
+                "vf-naming-policy" : "SDNC_Policy.ONAP_NF_NAMING_TIMESTAMP",
+                "k8s-rb-profile-name": "vfw-cnf-cds-base-profile",
+                "management-prefix-id" : 3
+            }
+        }
+    }
+}' | jq '.payload | .["resource-assignment-response"] | .["meshed-template"] | .'$TEMPLATE_NAME' | fromjson | .["resource-accumulator-resolved-data"] '
diff --git a/heat/vFW_CNF_CDS/templates/cba-dev/run-vf-pkg-ra.sh b/heat/vFW_CNF_CDS/templates/cba-dev/run-vf-pkg-ra.sh
new file mode 100755 (executable)
index 0000000..b783562
--- /dev/null
@@ -0,0 +1,67 @@
+#!/bin/sh
+
+# ============LICENSE_START=======================================================
+# Copyright (C) 2020 Orange
+# ================================================================================
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#      http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+# ============LICENSE_END=========================================================
+
+REQ_ID=`shuf -i 1-1000000 -n 1`
+SUB_REQ_ID=$REQ_ID"-"`shuf -i 1-1000 -n 1`
+TEMPLATE_NAME="vpkg"
+
+curl --location --request POST 'http://localhost:8081/api/v1/execution-service/process' \
+--header 'Authorization: Basic Y2NzZGthcHBzOmNjc2RrYXBwcw==' \
+--header 'Content-Type: application/json' \
+--data-raw '{
+    "commonHeader": {
+        "originatorId": "onap-me-cm-adapter",
+        "requestId": "'$REQ_ID'",
+        "subRequestId": "'$SUB_REQ_ID'"
+    },
+    "actionIdentifiers": {
+        "blueprintName": "vFW_CNF_CDS",
+        "blueprintVersion": "7.0.0",
+        "actionName": "resource-assignment",
+        "mode": "sync"
+    },
+    "payload": {
+        "resource-assignment-request": {
+            "template-prefix": [
+                "'$TEMPLATE_NAME'"
+            ],
+            "resolution-key": "ra-test-resolution",
+            "resource-assignment-properties": {
+                "vpg-management-port": 100,
+                "aic-cloud-region": "RegionOne",
+                "vnf-model-customization-uuid": "d73864db-1f6e-4e54-a533-a96773c926a4",
+                "service-instance-id": "2afee7c4-8b16-4f2f-a567-48fb7948abcf",
+                "vnf-id": "21dcbbd2-3ec2-4a9c-bb0d-599cafc16a1f",
+                "vnf_name": "sample-vnf-name",
+                "vf-module-name": "vf-module-name",
+                "vf-module-label": "'$TEMPLATE_NAME'",
+                "vf-module-type": "vf-module-type",
+                "vf-module-model-customization-uuid": "d3ae2df9-95d4-48cc-a466-9f12dee80458",
+                "vf-module-model-invariant-uuid": "564e55dc-3b90-4c9c-9e97-42f2c97d8f11",
+                "vf-module-model-version": "3d55e2a6-7634-4ceb-98e9-2852d621a544",
+                "vf-module-id": "3e6a0375-4b92-4bf5-9910-b0b893448a9c",
+                "vf-naming-policy" : "SDNC_Policy.ONAP_NF_NAMING_TIMESTAMP",
+                "k8s-rb-profile-name": "vpkg-modified",
+                "k8s-rb-profile-source": "vfw-cnf-cds-vpkg-profile",
+                "k8s-rb-profile-namespace": "test",
+                "management-prefix-id" : 3
+            }
+        }
+    }
+}' | jq '.payload | .["resource-assignment-response"] | .["meshed-template"] | .'$TEMPLATE_NAME' | fromjson | .["resource-accumulator-resolved-data"] '
diff --git a/heat/vFW_CNF_CDS/templates/cba-dev/run-vnf-ra.sh b/heat/vFW_CNF_CDS/templates/cba-dev/run-vnf-ra.sh
new file mode 100755 (executable)
index 0000000..8261ace
--- /dev/null
@@ -0,0 +1,61 @@
+#!/bin/sh
+
+# ============LICENSE_START=======================================================
+# Copyright (C) 2020 Orange
+# ================================================================================
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#      http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+# ============LICENSE_END=========================================================
+
+REQ_ID=`shuf -i 1-1000000 -n 1`
+SUB_REQ_ID=$REQ_ID"-"`shuf -i 1-1000 -n 1`
+
+curl --location --request POST 'http://localhost:8081/api/v1/execution-service/process' \
+--header 'Authorization: Basic Y2NzZGthcHBzOmNjc2RrYXBwcw==' \
+--header 'Content-Type: application/json' \
+--data-raw '{
+    "commonHeader": {
+        "originatorId": "onap-me-cm-adapter",
+        "requestId": "'$REQ_ID'",
+        "subRequestId": "'$SUB_REQ_ID'"
+    },
+    "actionIdentifiers": {
+        "blueprintName": "vFW_CNF_CDS",
+        "blueprintVersion": "7.0.0",
+        "actionName": "resource-assignment",
+        "mode": "sync"
+    },
+    "payload": {
+        "resource-assignment-request": {
+            "template-prefix": [
+                "vnf"
+            ],
+            "resolution-key": "ra-test-resolution",
+            "resource-assignment-properties": {
+                "vpg-management-port": 100,
+                "aic-cloud-region": "RegionOne",
+                "vnf-model-customization-uuid": "d73864db-1f6e-4e54-a533-a96773c926a4",
+                "service-instance-id": "2afee7c4-8b16-4f2f-a567-48fb7948abcf",
+                "vnf-id": "21dcbbd2-3ec2-4a9c-bb0d-599cafc16a1f",
+                "vnf_name": "sample-vnf-name",
+                "k8s-rb-profile-namespace": "vfw-namespace",
+                "int_private1_net_cidr" : "192.168.10.0/24",
+                "int_private2_net_cidr" : "192.168.20.0/24",
+                "onap_private_net_cidr" : "10.0.0.0/16",
+                "private1-prefix-id" : 2,
+                "private2-prefix-id" : 1
+            }
+        }
+    }
+}' | jq '.payload | .["resource-assignment-response"] | .["meshed-template"] | .vnf | fromjson | .["resource-accumulator-resolved-data"] '
+
index bf55ac5..77d0eb1 100644 (file)
             "file_ext": [
                 "vtl"
             ]
+        },
+        "artifact-k8sprofile-content": {
+            "description": "K8s Profile Folder Artifact",
+            "version": "1.0.0",
+            "derived_from": "tosca.artifacts.Implementation"
         }
     }
 }
index 2a534d4..5f3a2c0 100644 (file)
             "version": "1.0.0",
             "properties": {
                 "vpg-management-port": {
-                    "description": "SSH external port of ssh. When 0 ssh service will not be exposed",
+                    "description": "SSH external port of optional ssh service for vPKG.",
                     "type": "string",
                     "default": "0"
                 },
                 "k8s-rb-profile-namespace": {
                     "description": "K8s namespace to create helm chart for specified profile",
-                    "type": "string"
+                    "type": "string",
+                    "default": "default"
                 },
                 "k8s-rb-profile-name": {
                     "description": "Profile name used in multicloud/k8s plugin to identify Helm chart(s) where this mapping is providing override values.",
                     "type": "string"
                 },
+                "k8s-rb-profile-source": {
+                    "description": "The source folder or file relative to 'Templates/k8s-profiles' folder",
+                    "type": "string"
+                },
                 "private1-prefix-id": {
                     "description": "",
                     "required": false,
index 253f9dc..9ee224b 100644 (file)
@@ -5,8 +5,14 @@
             "version": "1.0.0",
             "attributes": {
                 "assignment-params": {
+                    "description": "Holds resolved template, resolution-summary or key-value",
                     "required": true,
                     "type": "string"
+                },
+                "assignment-map": {
+                    "description": "Holds resolved values for each artifact prefix eg. { vdns: { vnf-id: 123 } }",
+                    "required": true,
+                    "type": "map"
                 }
             },
             "capabilities": {
@@ -27,8 +33,8 @@
                                 "occurrence": {
                                     "description": "Number of time to perform the resolution.",
                                     "required": false,
-                                    "type": "integer",
-                                    "default": 1
+                                    "default": 1,
+                                    "type": "integer"
                                 },
                                 "store-result": {
                                     "description": "Whether or not to store the output.",
@@ -46,8 +52,8 @@
                                     "type": "boolean"
                                 },
                                 "artifact-prefix-names": {
-                                    "description": "Template , Resource Assignment Artifact Prefix names",
                                     "required": true,
+                                    "description": "Template , Resource Assignment Artifact Prefix names",
                                     "type": "list",
                                     "entry_schema": {
                                         "type": "string"
                                     "required": true,
                                     "type": "string"
                                 },
+                                "resource-assignment-map": {
+                                    "required": true,
+                                    "type": "string"
+                                },
                                 "status": {
                                     "required": true,
                                     "type": "string"
             },
             "derived_from": "tosca.nodes.Component"
         },
+        "component-k8s-profile-upload": {
+            "description": "This component is rendering and sending the k8s profile to the multicloud plugin.",
+            "version": "1.0.0",
+            "attributes": {
+                "statuses": {
+                    "required": true,
+                    "type": "json"
+                }
+            },
+            "capabilities": {
+                "component-node": {
+                    "type": "tosca.capabilities.Node"
+                }
+            },
+            "interfaces": {
+                "K8sProfileUploadComponent": {
+                    "operations": {
+                        "process": {
+                            "inputs": {
+                                "k8s-rb-profile-name": {
+                                    "description": "K8s profile name",
+                                    "required": false,
+                                    "type": "string"
+                                },
+                                "k8s-rb-definition-name": {
+                                    "description": "K8s definition name",
+                                    "required": false,
+                                    "type": "string"
+                                },
+                                "k8s-rb-definition-version": {
+                                    "description": "Version of the definition",
+                                    "required": false,
+                                    "type": "string"
+                                },
+                                "k8s-rb-profile-namespace": {
+                                    "description": "a K8s namespace for the profile",
+                                    "required": false,
+                                    "type": "string"
+                                },
+                                "k8s-rb-profile-source": {
+                                    "description": "Source (tgz/folder) for the template in CBA",
+                                    "required": false,
+                                    "type": "string"
+                                },
+                                "artifact-prefix-names": {
+                                    "description": "Resource Assignment Artifact Prefix names",
+                                    "required": false,
+                                    "type": "list",
+                                    "entry_schema": {
+                                        "type": "string"
+                                    }
+                                },
+                                "resource-assignment-map": {
+                                    "description": "Holds resolved values for each artifact prefix eg. { vdns: { vnf-id: 123 } }",
+                                    "required": false,
+                                    "type": "json"
+                                }
+                            },
+                            "outputs": {
+                                "statuses": {
+                                    "required": true,
+                                    "type": "string"
+                                }
+                            }
+                        }
+                    }
+                }
+            },
+            "derived_from": "tosca.nodes.Component"
+        },
         "source-capability": {
             "description": "This is Component Resource Source Node Type",
             "version": "1.0.0",
index 4c7aa47..63d83e4 100644 (file)
             "default": {
                 "type": "source-default",
                 "properties": {}
-            },
-            "sdnc": {
-                "type": "source-rest",
-                "properties": {
-                    "verb": "GET",
-                    "type": "JSON",
-                    "url-path": "/restconf/config/GENERIC-RESOURCE-API:services/service/$service-instance-id/service-data/vnfs/vnf/$vnf-id/vnf-data/vnf-topology/vnf-parameters-data/param/k8s-rb-profile-name",
-                    "path": "/param/0/value",
-                    "input-key-mapping": {
-                        "service-instance-id": "service-instance-id",
-                        "vnf-id": "vnf-id"
-                    },
-                    "output-key-mapping": {
-                        "k8s-rb-profile-name": "value"
-                    },
-                    "key-dependencies": [
-                        "service-instance-id",
-                        "vnf-id"
-                    ]
-                }
             }
         }
     },
             }
         }
     },
+    "k8s-rb-profile-source": {
+        "tags": "k8s, cnf, profile, k8s-rb-profile-source",
+        "name": "k8s-rb-profile-source",
+        "property": {
+            "description": "The source folder or file relative to 'Templates/k8s-profiles' folder",
+            "type": "string"
+        },
+        "group": "default",
+        "updated-by": "Rajewski, Lukasz <lukasz.rajewski@orange.com>",
+        "sources": {
+            "input": {
+                "type": "source-input"
+            },
+            "default": {
+                "type": "source-default",
+                "properties": {}
+            }
+        }
+    },
     "management-prefix-id": {
         "tags": "management-prefix-id",
         "name": "management-prefix-id",
         "name": "vpg-management-port",
         "property": {
             "description": "vpg-management-port",
-            "type": "string"
+            "type": "integer"
         },
         "group": "default",
         "updated-by": "Rajewski, Lukasz <lukasz.rajewski@orange.com>",
index 077bbc8..3fa4e87 100644 (file)
@@ -2,11 +2,11 @@
     "tosca_definitions_version": "controller_blueprint_1_0_0",
     "metadata": {
         "template_author": "Samuli Silvius <s.silvius@partner.samsung.com>",
-        "author-email": "abdelmuhaimen.seaudi@orange.com",
+        "author-email": "lukasz.rajewski@orange.com",
         "user-groups": "ADMIN, OPERATION",
         "template_name": "vFW_CNF_CDS",
-        "template_version": "1.0.45",
-        "template_tags": "Samuli Silvius, vFW_CNF_CDS",
+        "template_version": "7.0.0",
+        "template_tags": "Samuli Silvius, Lukasz Rajewski, vFW_CNF_CDS",
         "template_type": "DEFAULT"
     },
     "imports": [
             "username": "admin",
             "password": "admin"
         },
-        "multicloud-k8s-api": {
-            "type": "basic-auth",
-            "username": "admin",
-            "password": "admin",
-            "url": "http://multicloud-k8s:9015"
-        },
-        "profile-upload-properties": {
-            "assignment-params": {
-                "get_attribute": [
-                    "resource-assignment",
-                    "assignment-params"
-                ]
-            },
-            "profile-modification-decision-data": {
-                "get_input": "vpg-management-port"
-            },
-            "profile-artifacts": {
-                "get_attribute": [
-                    "profile-modification",
-                    "assignment-params"
-                ]
-            },
-            "api-access": "*multicloud-k8s-api"
-        },
         "config-deploy-properties": {
             "resolution-key": {
                 "get_input": "resolution-key"
                                 "call_operation": "ResourceResolutionComponent.process"
                             }
                         ],
-                        "on_success": [
-                            "profile-modification"
-                        ]
-                    },
-                    "profile-modification": {
-                        "description": "Profile Modification Resources",
-                        "target": "profile-modification",
-                        "activities": [
-                            {
-                                "call_operation": "ResourceResolutionComponent.process"
-                            }
-                        ],
                         "on_success": [
                             "profile-upload"
                         ]
                     },
                     "profile-upload": {
-                        "description": "Upload K8s Profile",
-                        "target": "profile-upload",
+                        "description": "Generate and upload K8s Profile",
+                        "target": "k8s-profile-upload",
                         "activities": [
                             {
                                 "call_operation": "ComponentScriptExecutor.process"
                     }
                 }
             },
-            "profile-modification": {
-                "type": "component-resource-resolution",
+            "k8s-profile-upload": {
+                "type": "component-k8s-profile-upload",
                 "interfaces": {
-                    "ResourceResolutionComponent": {
+                    "K8sProfileUploadComponent": {
                         "operations": {
                             "process": {
                                 "inputs": {
-                                    "artifact-prefix-names": [
-                                        "ssh-service"
-                                    ]
+                                    "artifact-prefix-names": {
+                                        "get_input": "template-prefix"
+                                    },
+                                    "resource-assignment-map": {
+                                        "get_attribute": [
+                                            "resource-assignment",
+                                            "assignment-map"
+                                        ]
+                                    }
                                 }
                             }
                         }
                     }
                 },
                 "artifacts": {
-                    "ssh-service-template": {
-                        "type": "artifact-template-velocity",
-                        "file": "Templates/k8s-profiles/ssh-service-template.vtl"
+                    "vfw-cnf-cds-base-profile": {
+                        "type": "artifact-k8sprofile-content",
+                        "file": "Templates/k8s-profiles/vfw-cnf-cds-base-profile.tar.gz"
+                    },
+                    "vfw-cnf-cds-vpkg-profile": {
+                        "type": "artifact-k8sprofile-content",
+                        "file": "Templates/k8s-profiles/vfw-cnf-cds-vpkg-profile"
                     },
-                    "ssh-service-mapping": {
+                    "vfw-cnf-cds-vpkg-profile-mapping": {
                         "type": "artifact-mapping-resource",
-                        "file": "Templates/k8s-profiles/ssh-service-mapping.json"
-                    }
-                }
-            },
-            "profile-upload": {
-                "type": "component-script-executor",
-                "interfaces": {
-                    "ComponentScriptExecutor": {
-                        "operations": {
-                            "process": {
-                                "inputs": {
-                                    "script-type": "kotlin",
-                                    "script-class-reference": "org.onap.ccsdk.cds.blueprintsprocessor.services.execution.scripts.K8sProfileUpload",
-                                    "dynamic-properties": "*profile-upload-properties"
-                                }
-                            }
-                        }
+                        "file": "Templates/k8s-profiles/vfw-cnf-cds-vpkg-profile/ssh-service-mapping.json"
                     }
                 }
             },
diff --git a/heat/vFW_CNF_CDS/templates/cba/Scripts/kotlin/KotlinK8sProfileUpload.kt b/heat/vFW_CNF_CDS/templates/cba/Scripts/kotlin/KotlinK8sProfileUpload.kt
deleted file mode 100644 (file)
index d47b476..0000000
+++ /dev/null
@@ -1,379 +0,0 @@
-/*
- * Copyright © 2019 Orange
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-package org.onap.ccsdk.cds.blueprintsprocessor.services.execution.scripts
-
-import com.fasterxml.jackson.databind.node.ObjectNode
-import com.fasterxml.jackson.databind.ObjectMapper
-import org.onap.ccsdk.cds.blueprintsprocessor.core.api.data.ExecutionServiceInput
-import org.onap.ccsdk.cds.blueprintsprocessor.rest.BasicAuthRestClientProperties
-import org.onap.ccsdk.cds.blueprintsprocessor.rest.RestClientProperties
-import org.onap.ccsdk.cds.blueprintsprocessor.rest.service.BasicAuthRestClientService
-import org.onap.ccsdk.cds.blueprintsprocessor.rest.service.BlueprintWebClientService
-import org.onap.ccsdk.cds.blueprintsprocessor.rest.service.RestLoggerService
-import org.onap.ccsdk.cds.blueprintsprocessor.services.execution.AbstractScriptComponentFunction
-import org.onap.ccsdk.cds.controllerblueprints.core.utils.JacksonUtils
-import org.onap.ccsdk.cds.controllerblueprints.core.utils.BluePrintArchiveUtils
-import org.onap.ccsdk.cds.controllerblueprints.core.utils.ArchiveType
-import org.apache.commons.io.IOUtils
-import org.apache.commons.io.FilenameUtils
-import org.apache.http.client.entity.EntityBuilder
-import org.apache.http.entity.ContentType
-import org.apache.http.message.BasicHeader
-import org.apache.http.client.methods.HttpPost
-import org.apache.http.client.methods.HttpUriRequest
-import org.apache.http.client.ClientProtocolException
-import org.slf4j.LoggerFactory
-import org.springframework.http.HttpMethod
-import org.springframework.web.client.RestTemplate
-import com.fasterxml.jackson.annotation.JsonIgnore
-import com.fasterxml.jackson.annotation.JsonProperty
-import java.util.ArrayList
-import java.util.LinkedHashMap
-import java.io.IOException
-import java.io.File
-import java.nio.file.Files
-import java.nio.file.Paths
-import java.nio.file.Path
-import org.springframework.http.HttpHeaders
-import org.springframework.http.MediaType
-import java.nio.charset.Charset
-import java.util.Base64
-import org.onap.ccsdk.cds.controllerblueprints.core.BluePrintProcessorException
-import org.yaml.snakeyaml.Yaml
-
-open class K8sProfileUpload : AbstractScriptComponentFunction() {
-
-    private val log = LoggerFactory.getLogger(K8sProfileUpload::class.java)!!
-
-    override fun getName(): String {
-        return "K8sProfileUpload"
-    }
-
-    override suspend fun processNB(executionRequest: ExecutionServiceInput) {
-        log.info("executing K8s Profile Upload script")
-
-        val baseK8sApiUrl = getDynamicProperties("api-access").get("url").asText()
-        val k8sApiUsername = getDynamicProperties("api-access").get("username").asText()
-        val k8sApiPassword = getDynamicProperties("api-access").get("password").asText()
-
-        val prefixList: ArrayList<String> = getTemplatePrefixList(executionRequest)
-
-        for (prefix in prefixList) {
-            if (prefix.toLowerCase().equals("vnf")) {
-                log.info("For vnf-level resource-assignment, profile upload is not performed")
-                continue
-            }
-
-            val assignmentParams = getDynamicProperties("assignment-params")
-            val payloadObject = JacksonUtils.jsonNode(assignmentParams.get(prefix).asText()) as ObjectNode
-
-            log.info("Uploading K8S profile for template prefix $prefix")
-
-            val vfModuleModelInvariantUuid: String = getResolvedParameter(payloadObject, "vf-module-model-invariant-uuid")
-            val vfModuleModelUuid: String = getResolvedParameter(payloadObject, "vf-module-model-version")
-            val k8sRbProfileName: String = getResolvedParameter(payloadObject, "k8s-rb-profile-name")
-            val k8sRbProfileNamespace: String = getResolvedParameter(payloadObject, "k8s-rb-profile-namespace")
-
-            val api = K8sApi(k8sApiUsername, k8sApiPassword, baseK8sApiUrl, vfModuleModelInvariantUuid, vfModuleModelUuid)
-
-            if (!api.hasDefinition()) {
-                throw BluePrintProcessorException("K8s RB Definition (${vfModuleModelInvariantUuid}/${vfModuleModelUuid}) not found ")
-            }
-
-            log.info("k8s-rb-profile-name: $k8sRbProfileName")
-            if (k8sRbProfileName.equals("")) {
-                throw BluePrintProcessorException("K8s rb profile name is empty! Either define profile name to use or choose default")
-            }
-            if (k8sRbProfileName.equals("default") and api.hasProfile(k8sRbProfileName)) {
-                log.info("Using default profile - skipping upload")
-            } else {
-                if (api.hasProfile(k8sRbProfileName)) {
-                    log.info("Profile Already Existing - skipping upload")
-                } else {
-                    val profileFilePath: Path = prepareProfileFile(k8sRbProfileName, prefix.equals("vpkg"))
-
-                    var profile = K8sProfile()
-                    profile.profileName = k8sRbProfileName
-                    profile.rbName = vfModuleModelInvariantUuid
-                    profile.rbVersion = vfModuleModelUuid
-                    profile.namespace = k8sRbProfileNamespace
-                    api.createProfile(profile)
-                    api.uploadProfileContent(profile, profileFilePath)
-
-                    log.info("K8s Profile Upload Completed")
-                }
-            }
-        }
-    }
-
-    fun prepareProfileFile(k8sRbProfileName: String, profileModificationAllowed: Boolean): Path {
-        val bluePrintContext = bluePrintRuntimeService.bluePrintContext()
-        val bluePrintBasePath: String = bluePrintContext.rootPath
-        var profileFilePath: Path = Paths.get(bluePrintBasePath.plus(File.separator).plus("Templates").plus(File.separator).plus("k8s-profiles").plus(File.separator).plus("${k8sRbProfileName}.tar.gz"))
-        log.info("Reading K8s profile file: ${profileFilePath}")
-
-        val profileFile = profileFilePath.toFile()
-
-        if (!profileFile.exists())
-            throw BluePrintProcessorException("K8s Profile template file ${profileFilePath} does not exists")
-
-        val tempMainPath: File = createTempDir("k8s-profile-", "")
-        val tempProfilePath: File = createTempDir("${k8sRbProfileName}-", "", tempMainPath)
-        log.info("Decompressing profile to ${tempProfilePath.toString()}")
-
-        val decompressedProfile: File = BluePrintArchiveUtils.deCompress(profileFilePath.toFile(),
-                "${tempProfilePath.toString()}", ArchiveType.TarGz)
-
-        log.info("${profileFilePath.toString()} decompression completed")
-
-        if (profileModificationAllowed) {
-            //Here we can add extra files inside the archive
-            val profileModificationDecisionData = getDynamicProperties("profile-modification-decision-data")
-            log.info("Profile modification decision data: ${profileModificationDecisionData}")
-            if (profileModificationDecisionData != null && profileModificationDecisionData.asText().toInt() > 0) {
-                log.info("Modification of profile content")
-
-                val profileArtifacts = getDynamicProperties("profile-artifacts")
-                val sshServiceFileContent = profileArtifacts.get("ssh-service").asText()
-                val sshServiceFileName = "ssh-service.yaml"
-                val serviceFilePath = tempProfilePath.toString().plus(File.separator).plus(sshServiceFileName)
-                File(serviceFilePath).bufferedWriter().use { out -> out.write(sshServiceFileContent) }
-                val manifestFileName = tempProfilePath.toString().plus(File.separator).plus("manifest.yaml")
-                var finalManifest = ""
-                File(manifestFileName).bufferedReader().use { inr ->
-                    val manifestYaml = Yaml()
-                    val manifestObject: Map<String, Any> = manifestYaml.load(inr)
-                    val typeObject: MutableMap<String, Any> = manifestObject.get("type") as MutableMap<String, Any>
-                    if (!typeObject.containsKey("configresource"))
-                        typeObject.put("configresource", ArrayList<LinkedHashMap<String, Any>>())
-                    val configFiles: MutableList<LinkedHashMap<String, Any>> = typeObject.get("configresource") as MutableList<LinkedHashMap<String, Any>>
-                    val sshConfigFile = LinkedHashMap<String, Any>()
-                    sshConfigFile.put("filepath", sshServiceFileName)
-                    sshConfigFile.put("chartpath", "vpkg/templates/${sshServiceFileName}")
-                    configFiles.add(sshConfigFile)
-                    finalManifest = manifestYaml.dump(manifestObject)
-                }
-                File(manifestFileName).bufferedWriter().use { out -> out.write(finalManifest) }
-                log.info("Modified K8s profile manifest file")
-                log.info(finalManifest)
-                log.info("Modification of profile completed")
-            }
-        }
-
-        profileFilePath = Paths.get(tempMainPath.toString().plus(File.separator).plus("${k8sRbProfileName}.tar.gz"))
-
-        if (!BluePrintArchiveUtils.compress(decompressedProfile, profileFilePath.toFile(),
-                        ArchiveType.TarGz)) {
-            throw BluePrintProcessorException("Profile compression has failed")
-        }
-
-        log.info("${profileFilePath.toString()} compression completed")
-
-        return profileFilePath
-    }
-
-    fun getTemplatePrefixList(executionRequest: ExecutionServiceInput): ArrayList<String> {
-        val result = ArrayList<String>()
-        for (prefix in executionRequest.payload.get("resource-assignment-request").get("template-prefix").elements())
-            result.add(prefix.asText())
-        return result
-    }
-
-    fun getResolvedParameter(payload: ObjectNode, keyName: String): String {
-        for (node in payload.get("resource-accumulator-resolved-data").elements()) {
-            if (node.get("param-name").asText().equals(keyName)) {
-                return node.get("param-value").asText()
-            }
-        }
-        return ""
-    }
-
-    override suspend fun recoverNB(runtimeException: RuntimeException, executionRequest: ExecutionServiceInput) {
-        log.info("Executing Recovery")
-        bluePrintRuntimeService.getBluePrintError().addError("${runtimeException.message}")
-    }
-
-    inner class K8sApi(val username: String, val password: String, val baseUrl: String, val definition: String,
-                       val definitionVersion: String) {
-        private val service: UploadFileRestClientService //BasicAuthRestClientService
-
-        init {
-            var mapOfHeaders = hashMapOf<String, String>()
-            mapOfHeaders.put("Accept", "application/json")
-            mapOfHeaders.put("Content-Type", "application/json")
-            mapOfHeaders.put("cache-control", " no-cache")
-            mapOfHeaders.put("Accept", "application/json")
-            var basicAuthRestClientProperties: BasicAuthRestClientProperties = BasicAuthRestClientProperties()
-            basicAuthRestClientProperties.username = username
-            basicAuthRestClientProperties.password = password
-            basicAuthRestClientProperties.url = "$baseUrl/v1/rb/definition/${definition}/${definitionVersion}"
-            basicAuthRestClientProperties.additionalHeaders = mapOfHeaders
-
-            this.service = UploadFileRestClientService(basicAuthRestClientProperties)
-        }
-
-        fun hasDefinition(): Boolean {
-            try {
-                val result: BlueprintWebClientService.WebClientResponse<String> = service.exchangeResource(HttpMethod.GET.name, "", "")
-                print(result)
-                if (result.status >= 200 && result.status < 300)
-                    return true
-                else
-                    return false
-            } catch (e: Exception) {
-                log.info("Caught exception trying to get k8s rb definition")
-                throw BluePrintProcessorException("${e.message}")
-            }
-        }
-
-        fun hasProfile(profileName: String): Boolean {
-            try {
-                val result: BlueprintWebClientService.WebClientResponse<String> = service.exchangeResource(HttpMethod.GET.name,
-                        "/profile/$profileName", "")
-                if (result.status >= 200 && result.status < 300)
-                    return true
-                else {
-                    print(result)
-                    return false
-                }
-            } catch (e: Exception) {
-                log.info("Caught exception trying to get k8s rb profile")
-                throw BluePrintProcessorException("${e.message}")
-            }
-        }
-
-        fun createProfile(profile: K8sProfile) {
-            val objectMapper = ObjectMapper()
-            val profileJsonString: String = objectMapper.writeValueAsString(profile)
-            try {
-                val result: BlueprintWebClientService.WebClientResponse<String> = service.exchangeResource(HttpMethod.POST.name,
-                        "/profile", profileJsonString)
-                if (result.status < 200 || result.status >= 300) {
-                    throw Exception(result.body)
-                }
-            } catch (e: Exception) {
-                log.info("Caught exception trying to create k8s rb profile ${profile.profileName}")
-                throw BluePrintProcessorException("${e.message}")
-            }
-        }
-
-        fun uploadProfileContent(profile: K8sProfile, filePath: Path) {
-            try {
-                val result: BlueprintWebClientService.WebClientResponse<String> = service.uploadBinaryFile(
-                        "/profile/${profile.profileName}/content", filePath)
-                if (result.status < 200 || result.status >= 300) {
-                    throw Exception(result.body)
-                }
-            } catch (e: Exception) {
-                log.info("Caught exception trying to upload k8s rb profile ${profile.profileName}")
-                throw BluePrintProcessorException("${e.message}")
-            }
-        }
-    }
-}
-
-class UploadFileRestClientService(
-        private val restClientProperties:
-        BasicAuthRestClientProperties
-) : BlueprintWebClientService {
-
-    override fun defaultHeaders(): Map<String, String> {
-
-        val encodedCredentials = setBasicAuth(
-                restClientProperties.username,
-                restClientProperties.password
-        )
-        return mapOf(
-                HttpHeaders.CONTENT_TYPE to MediaType.APPLICATION_JSON_VALUE,
-                HttpHeaders.ACCEPT to MediaType.APPLICATION_JSON_VALUE,
-                HttpHeaders.AUTHORIZATION to "Basic $encodedCredentials"
-        )
-    }
-
-    override fun host(uri: String): String {
-        return restClientProperties.url + uri
-    }
-
-    override fun convertToBasicHeaders(headers: Map<String, String>):
-            Array<BasicHeader> {
-        val customHeaders: MutableMap<String, String> = headers.toMutableMap()
-        // inject additionalHeaders
-        customHeaders.putAll(verifyAdditionalHeaders(restClientProperties))
-
-        if (!headers.containsKey(HttpHeaders.AUTHORIZATION)) {
-            val encodedCredentials = setBasicAuth(
-                    restClientProperties.username,
-                    restClientProperties.password
-            )
-            customHeaders[HttpHeaders.AUTHORIZATION] =
-                    "Basic $encodedCredentials"
-        }
-        return super.convertToBasicHeaders(customHeaders)
-    }
-
-    private fun setBasicAuth(username: String, password: String): String {
-        val credentialsString = "$username:$password"
-        return Base64.getEncoder().encodeToString(
-                credentialsString.toByteArray(Charset.defaultCharset())
-        )
-    }
-
-    @Throws(IOException::class, ClientProtocolException::class)
-    private fun performHttpCall(httpUriRequest: HttpUriRequest): BlueprintWebClientService.WebClientResponse<String> {
-        val httpResponse = httpClient().execute(httpUriRequest)
-        val statusCode = httpResponse.statusLine.statusCode
-        httpResponse.entity.content.use {
-            val body = IOUtils.toString(it, Charset.defaultCharset())
-            return BlueprintWebClientService.WebClientResponse(statusCode, body)
-        }
-    }
-
-    fun uploadBinaryFile(path: String, filePath: Path): BlueprintWebClientService.WebClientResponse<String> {
-        val convertedHeaders: Array<BasicHeader> = convertToBasicHeaders(defaultHeaders())
-        val httpPost = HttpPost(host(path))
-        val entity = EntityBuilder.create().setBinary(Files.readAllBytes(filePath)).build()
-        httpPost.setEntity(entity)
-        RestLoggerService.httpInvoking(convertedHeaders)
-        httpPost.setHeaders(convertedHeaders)
-        return performHttpCall(httpPost)
-    }
-}
-
-class K8sProfile {
-    @get:JsonProperty("rb-name")
-    var rbName: String? = null
-    @get:JsonProperty("rb-version")
-    var rbVersion: String? = null
-    @get:JsonProperty("profile-name")
-    var profileName: String? = null
-    @get:JsonProperty("namespace")
-    var namespace: String? = "default"
-
-    override fun toString(): String {
-        return "$rbName:$rbVersion:$profileName"
-    }
-
-    override fun equals(other: Any?): Boolean {
-        if (this === other) return true
-        if (javaClass != other?.javaClass) return false
-        return true
-    }
-
-    override fun hashCode(): Int {
-        return javaClass.hashCode()
-    }
-}
index 80d82af..fd11bfb 100644 (file)
@@ -3,6 +3,6 @@ CSAR-Version: 1.0
 Created-By: Samuli Silvius <s.silvius@partner.samsung.com>
 Entry-Definitions: Definitions/vFW_CNF_CDS.json
 Template-Name: vFW_CNF_CDS
-Template-Version: 1.0.45
+Template-Version: 7.0.0
 Template-Type: DEFAULT
-Template-Tags: Samuli Silvius, vFW_CNF_CDS
+Template-Tags: Samuli Silvius, Lukasz Rajewski, vFW_CNF_CDS
index dd49ad2..53cd0f7 100644 (file)
     {
         "name": "k8s-rb-profile-namespace",
         "property": {
-            "description": "K8s namespace to create helm chart for specified profile",
-            "type": "string"
+            "description": "K8s namespace to create helm chart for specified RB profile",
+            "type": "string",
+            "required": false,
+            "default": "default"
         },
         "input-param": false,
         "dictionary-name": "k8s-rb-profile-namespace",
         "dictionary-source": "sdnc",
-        "dependencies": [
-            "service-instance-id",
-            "vnf-id"
-        ]
+        "dependencies": []
     },
     {
         "name": "k8s-rb-profile-name",
         "property": {
-            "description": "Profile name used in multicloud/k8s plugin to identify Helm chart(s) where this mapping is providing override values.",
-            "type": "string"
+            "description": "RB Profile name used in k8s plugin to identify Helm chart(s) where this mapping is providing override values.",
+            "type": "string",
+            "required": false,
+            "default": "default"
         },
         "input-param": false,
         "dictionary-name": "k8s-rb-profile-name",
-        "dictionary-source": "sdnc",
+        "dictionary-source": "default",
+        "dependencies": []
+    },
+    {
+        "name": "k8s-rb-definition-name",
+        "property": {
+            "description": "RB Name identifier of Helm chart(s) in k8s plugin",
+            "type": "string",
+            "required": false,
+            "metadata": {
+                "transform-template": "${vf-module-model-invariant-uuid}"
+            }
+        },
+        "input-param": false,
+        "dictionary-name": "k8s-rb-definition-name",
+        "dictionary-source": "default",
         "dependencies": [
-            "service-instance-id",
-            "vnf-id"
+            "vf-module-model-invariant-uuid"
         ]
+    },
+    {
+        "name": "k8s-rb-definition-version",
+        "property": {
+            "description": "RB Version identifier of Helm chart(s) in k8s plugin",
+            "type": "string",
+            "required": false,
+            "metadata": {
+                "transform-template": "${vf-module-model-version}"
+            }
+        },
+        "input-param": false,
+        "dictionary-name": "k8s-rb-definition-version",
+        "dictionary-source": "default",
+        "dependencies": [
+            "vf-module-model-version"
+        ]
+    },
+    {
+        "name": "k8s-rb-profile-source",
+        "property": {
+            "description": "The source folder or file relative to 'Templates/k8s-profiles' folder",
+            "type": "string",
+            "required": true
+        },
+        "input-param": false,
+        "dictionary-name": "k8s-rb-profile-source",
+        "dictionary-source": "default",
+        "dependencies": []
     }
 ]
index 401a0bd..a6bc57b 100644 (file)
             "param-name": "k8s-rb-profile-name",
             "param-value": "${k8s-rb-profile-name}"
         },
-        {
-            "param-name": "k8s-rb-profile-namespace",
-            "param-value": "${k8s-rb-profile-namespace}"
-        },
         {
             "param-name": "int_private1_subnet_id",
             "param-value": "unprotected-network-subnet-1"
diff --git a/heat/vFW_CNF_CDS/templates/cba/Templates/k8s-profiles/vfw-cnf-cds-vpkg-profile/manifest.yaml b/heat/vFW_CNF_CDS/templates/cba/Templates/k8s-profiles/vfw-cnf-cds-vpkg-profile/manifest.yaml
new file mode 100644 (file)
index 0000000..adb9f86
--- /dev/null
@@ -0,0 +1,7 @@
+---
+version: v1
+type:
+  values: "override_values.yaml"
+  configresource:
+    - filepath: ssh-service-template.yaml
+      chartpath: vpkg/templates/ssh-service-template.yaml
diff --git a/heat/vFW_CNF_CDS/templates/cba/Templates/k8s-profiles/vfw-cnf-cds-vpkg-profile/override_values.yaml b/heat/vFW_CNF_CDS/templates/cba/Templates/k8s-profiles/vfw-cnf-cds-vpkg-profile/override_values.yaml
new file mode 100644 (file)
index 0000000..8b13789
--- /dev/null
@@ -0,0 +1 @@
+
@@ -2,8 +2,8 @@
     {
         "name": "vpg-management-port",
         "property": {
-            "description": "The number of node port for ssh service of vpg. 0 means that ssh service will not be exposed",
-            "type": "string",
+            "description": "The number of node port for ssh service of vpg",
+            "type": "integer",
             "default": "0"
         },
         "input-param": false,
index 2eae129..ff3dfd8 100644 (file)
     {
         "name": "k8s-rb-profile-namespace",
         "property": {
-            "description": "K8s namespace to create helm chart for specified profile",
-            "type": "string"
+            "description": "K8s namespace to create helm chart for specified RB profile",
+            "type": "string",
+            "required": false,
+            "default": "default"
         },
         "input-param": false,
         "dictionary-name": "k8s-rb-profile-namespace",
         "dictionary-source": "sdnc",
-        "dependencies": [
-            "service-instance-id",
-            "vnf-id"
-        ]
+        "dependencies": []
     },
     {
         "name": "k8s-rb-profile-name",
         "property": {
-            "description": "Profile name used in multicloud/k8s plugin to identify Helm chart(s) where this mapping is providing override values.",
-            "type": "string"
+            "description": "RB Profile name used in k8s plugin to identify Helm chart(s) where this mapping is providing override values.",
+            "type": "string",
+            "required": false,
+            "default": "default"
         },
         "input-param": false,
         "dictionary-name": "k8s-rb-profile-name",
-        "dictionary-source": "sdnc",
+        "dictionary-source": "default",
+        "dependencies": []
+    },
+    {
+        "name": "k8s-rb-definition-name",
+        "property": {
+            "description": "RB Name identifier of Helm chart(s) in k8s plugin",
+            "type": "string",
+            "required": false,
+            "metadata": {
+                "transform-template": "${vf-module-model-invariant-uuid}"
+            }
+        },
+        "input-param": false,
+        "dictionary-name": "k8s-rb-definition-name",
+        "dictionary-source": "default",
         "dependencies": [
-            "service-instance-id",
-            "vnf-id"
+            "vf-module-model-invariant-uuid"
         ]
+    },
+    {
+        "name": "k8s-rb-definition-version",
+        "property": {
+            "description": "RB Version identifier of Helm chart(s) in k8s plugin",
+            "type": "string",
+            "required": false,
+            "metadata": {
+                "transform-template": "${vf-module-model-version}"
+            }
+        },
+        "input-param": false,
+        "dictionary-name": "k8s-rb-definition-version",
+        "dictionary-source": "default",
+        "dependencies": [
+            "vf-module-model-version"
+        ]
+    },
+    {
+        "name": "k8s-rb-profile-source",
+        "property": {
+            "description": "The source folder or file relative to 'Templates/k8s-profiles' folder",
+            "type": "string",
+            "required": true
+        },
+        "input-param": false,
+        "dictionary-name": "k8s-rb-profile-source",
+        "dictionary-source": "default",
+        "dependencies": []
     }
 ]
index d65b6f9..55f9451 100644 (file)
         {
             "param-name": "k8s-rb-profile-name",
             "param-value": "${k8s-rb-profile-name}"
-        },
-        {
-            "param-name": "k8s-rb-profile-namespace",
-            "param-value": "${k8s-rb-profile-namespace}"
         }
     ]
 }
index bee80d1..c6411d7 100644 (file)
         "dependencies": [],
         "version": 0
     },
-    {
-        "name": "k8s-rb-profile-name",
-        "property": {
-            "description": "Profile name used in multicloud/k8s plugin to identify Helm chart(s) where this mapping is providing override values.",
-            "type": "string",
-            "default": "vfw-cnf-cds-base-profile"
-        },
-        "input-param": false,
-        "dictionary-name": "k8s-rb-profile-name",
-        "dictionary-source": "default",
-        "dependencies": []
-    },
     {
         "name": "k8s-rb-profile-namespace",
         "property": {
index 7acdc54..9e23665 100644 (file)
         {
             "param-name": "demo_artifacts_version",
             "param-value": "${demo_artifacts_version}"
-        },
-        {
-            "param-name": "k8s-rb-profile-name",
-            "param-value": "${k8s-rb-profile-name}"
-        },
-        {
-            "param-name": "k8s-rb-profile-namespace",
-            "param-value": "${k8s-rb-profile-namespace}"
         }
     ]
 }
index 4a1b915..86217c1 100644 (file)
     {
         "name": "k8s-rb-profile-namespace",
         "property": {
-            "description": "K8s namespace to create helm chart for specified profile",
-            "type": "string"
+            "description": "K8s namespace to create helm chart for specified RB profile",
+            "type": "string",
+            "required": false,
+            "default": "default"
         },
         "input-param": false,
         "dictionary-name": "k8s-rb-profile-namespace",
         "dictionary-source": "sdnc",
-        "dependencies": [
-            "service-instance-id",
-            "vnf-id"
-        ]
+        "dependencies": []
     },
     {
         "name": "k8s-rb-profile-name",
         "property": {
-            "description": "Profile name used in multicloud/k8s plugin to identify Helm chart(s) where this mapping is providing override values.",
-            "type": "string"
+            "description": "RB Profile name used in k8s plugin to identify Helm chart(s) where this mapping is providing override values.",
+            "type": "string",
+            "required": false,
+            "default": "default"
         },
         "input-param": false,
         "dictionary-name": "k8s-rb-profile-name",
-        "dictionary-source": "sdnc",
+        "dictionary-source": "default",
+        "dependencies": []
+    },
+    {
+        "name": "k8s-rb-definition-name",
+        "property": {
+            "description": "RB Name identifier of Helm chart(s) in k8s plugin",
+            "type": "string",
+            "required": false,
+            "metadata": {
+                "transform-template": "${vf-module-model-invariant-uuid}"
+            }
+        },
+        "input-param": false,
+        "dictionary-name": "k8s-rb-definition-name",
+        "dictionary-source": "default",
         "dependencies": [
-            "service-instance-id",
-            "vnf-id"
+            "vf-module-model-invariant-uuid"
         ]
+    },
+    {
+        "name": "k8s-rb-definition-version",
+        "property": {
+            "description": "RB Version identifier of Helm chart(s) in k8s plugin",
+            "type": "string",
+            "required": false,
+            "metadata": {
+                "transform-template": "${vf-module-model-version}"
+            }
+        },
+        "input-param": false,
+        "dictionary-name": "k8s-rb-definition-version",
+        "dictionary-source": "default",
+        "dependencies": [
+            "vf-module-model-version"
+        ]
+    },
+    {
+        "name": "k8s-rb-profile-source",
+        "property": {
+            "description": "The source folder or file relative to 'Templates/k8s-profiles' folder",
+            "type": "string",
+            "required": true
+        },
+        "input-param": false,
+        "dictionary-name": "k8s-rb-profile-source",
+        "dictionary-source": "default",
+        "dependencies": []
     }
 ]
index 18511d5..2a6b798 100644 (file)
         {
             "param-name": "k8s-rb-profile-name",
             "param-value": "${k8s-rb-profile-name}"
-        },
-        {
-            "param-name": "k8s-rb-profile-namespace",
-            "param-value": "${k8s-rb-profile-namespace}"
         }
     ]
 }
index 3d3bbd2..edd834c 100644 (file)
     {
         "name": "k8s-rb-profile-namespace",
         "property": {
-            "description": "K8s namespace to create helm chart for specified profile",
-            "type": "string"
+            "description": "K8s namespace to create helm chart for specified RB profile",
+            "type": "string",
+            "required": false,
+            "default": "default"
         },
         "input-param": false,
         "dictionary-name": "k8s-rb-profile-namespace",
         "dictionary-source": "sdnc",
-        "dependencies": [
-            "service-instance-id",
-            "vnf-id"
-        ]
+        "dependencies": []
     },
     {
         "name": "k8s-rb-profile-name",
         "property": {
-            "description": "Profile name used in multicloud/k8s plugin to identify Helm chart(s) where this mapping is providing override values.",
-            "type": "string"
+            "description": "RB Profile name used in k8s plugin to identify Helm chart(s) where this mapping is providing override values.",
+            "type": "string",
+            "required": false,
+            "default": "default"
         },
         "input-param": false,
         "dictionary-name": "k8s-rb-profile-name",
-        "dictionary-source": "sdnc",
+        "dictionary-source": "default",
+        "dependencies": []
+    },
+    {
+        "name": "k8s-rb-definition-name",
+        "property": {
+            "description": "RB Name identifier of Helm chart(s) in k8s plugin",
+            "type": "string",
+            "required": false,
+            "metadata": {
+                "transform-template": "${vf-module-model-invariant-uuid}"
+            }
+        },
+        "input-param": false,
+        "dictionary-name": "k8s-rb-definition-name",
+        "dictionary-source": "default",
         "dependencies": [
-            "service-instance-id",
-            "vnf-id"
+            "vf-module-model-invariant-uuid"
         ]
+    },
+    {
+        "name": "k8s-rb-definition-version",
+        "property": {
+            "description": "RB Version identifier of Helm chart(s) in k8s plugin",
+            "type": "string",
+            "required": false,
+            "metadata": {
+                "transform-template": "${vf-module-model-version}"
+            }
+        },
+        "input-param": false,
+        "dictionary-name": "k8s-rb-definition-version",
+        "dictionary-source": "default",
+        "dependencies": [
+            "vf-module-model-version"
+        ]
+    },
+    {
+        "name": "k8s-rb-profile-source",
+        "property": {
+            "description": "The source folder or file relative to 'Templates/k8s-profiles' folder",
+            "type": "string",
+            "required": true
+        },
+        "input-param": false,
+        "dictionary-name": "k8s-rb-profile-source",
+        "dictionary-source": "default",
+        "dependencies": []
     }
 ]
index 3e2d8c1..4768ab8 100644 (file)
         {
             "param-name": "k8s-rb-profile-name",
             "param-value": "${k8s-rb-profile-name}"
-        },
-        {
-            "param-name": "k8s-rb-profile-namespace",
-            "param-value": "${k8s-rb-profile-namespace}"
         }
     ]
 }
diff --git a/heat/vFW_CNF_CDS/templates/cba/pom.xml b/heat/vFW_CNF_CDS/templates/cba/pom.xml
new file mode 100644 (file)
index 0000000..26bf93e
--- /dev/null
@@ -0,0 +1,43 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!--
+  ~ Copyright © 2020 Bell Canada
+  ~
+  ~ Licensed under the Apache License, Version 2.0 (the "License");
+  ~ you may not use this file except in compliance with the License.
+  ~ You may obtain a copy of the License at
+  ~
+  ~     http://www.apache.org/licenses/LICENSE-2.0
+  ~
+  ~ Unless required by applicable law or agreed to in writing, software
+  ~ distributed under the License is distributed on an "AS IS" BASIS,
+  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+  ~ See the License for the specific language governing permissions and
+  ~ limitations under the License.
+  -->
+
+<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
+    <modelVersion>4.0.0</modelVersion>
+
+    <parent>
+        <groupId>org.onap.ccsdk.cds.blueprintsprocessor</groupId>
+        <artifactId>test-blueprint-kotlin-parent</artifactId>
+        <version>1.0.0-SNAPSHOT</version>
+    </parent>
+
+    <artifactId>vFW_CNF_CDS</artifactId>
+    <version>1.0.0-SNAPSHOT</version>
+    <packaging>pom</packaging>
+
+    <properties>
+        <!-- Properties for -Pdeploy-cba -->
+        <cds.username>ccsdkapps</cds.username>
+        <cds.password>ccsdkapps</cds.password>
+        <!-- DEFAULTS
+        <cds.protocol>http</cds.protocol>
+        <cds.host>localhost</cds.host>
+        <cds.port>8081</cds.port>
+        <cds.enrich.endpoint>api/v1/blueprint-model/enrich</cds.enrich.endpoint>
+        <cds.publish.endpoint>api/v1/blueprint-model/publish</cds.publish.endpoint>
+        <ca></ca-->
+    </properties>
+</project>